*! 1.1.0 NJC 7 Sept 2008
*! 1.0.0 NJC 26 August 2007
program exptriplot
	version 8
	syntax varlist(min=3 max=3) [if] [in] ///
	[, A(numlist max=1 >0 <1) B(numlist max=1 >0) ///
	P(numlist max=1 >0) ///
	mesh MESH2(str asis) ///
	by(str) * ] 

	marksample touse
	qui count if `touse'
	if r(N) == 0 error 2000 

	if "`p'" != "" & "`a'`b'" != "" error 198 

	if "`p'" != "" { 
		local f @^`p'
	}
	else { 
		if "`a'" == "" local a = 0.5 
		if "`b'" == "" local b = 1 
		local f cond(@ <= `a', `a'^(1 - `b') * @^`b',   ///
			1 - (1 - `a')^(1 - `b') * (1 - @)^`b') 
	}

	if "`mesh'`mesh2'" != "" { 

	local T 00T 019 028 037 046 055 064 073 082 091 ///
                109 208 307 406 505 604 703 802 901 T00 ///
		0T0 190 280 370 460 550 640 730 820 910  
	
	foreach t in 118 127 136 145 154 163 172 181    ///
                     217 226 235 244 253 262 271        ///
		     316 325 334 343 352 361            ///
		     415 424 433 442 451                ///
		     514 523 532 541                    ///
		     613 622 631                        ///
		     712 721                            ///
		     811 `T' {                          
 
		forval i = 1/3 { 
			local c`i' = substr("`t'",`i',1) 
			if "`c`i''" == "T" local c`i' = 10 
		}

		local t = cond(index("`t'", "T"), "*", "`t'") 

		local y = `c1' / 10 
		local x = `c2' / 10 
		local z = `c3' / 10 

		local fx : subinstr local f "@" "`x'", all
		local fy : subinstr local f "@" "`y'", all
		local fz : subinstr local f "@" "`z'", all

		local tu = ((`fx') - (`fz')) / sqrt(2) 
		local tv = (2 * (`fy') - (`fx') - (`fz')) / sqrt(6) 		
		local call `" `call' `tv' `tu' (0) "`t'" "' 
	} 

	local mesh twoway scatteri `call', ///
	ms(i) mlabcolor(gs10) legend(off) `mesh2' || 
	} 

	tempvar V U 
	tokenize "`varlist'" 
	args Y X Z 
	local fX : subinstr local f "@" "`X'", all
	local fY : subinstr local f "@" "`Y'", all
	local fZ : subinstr local f "@" "`Z'", all
	gen `U' = ((`fX') - (`fZ')) / sqrt(2) 
	gen `V' = (2 * (`fY') - (`fX') - (`fZ')) / sqrt(6) 

	if `"`by'"' != "" { 
		gettoken byvar byopts : by, parse(",") 
		gettoken comma byopts : byopts, parse(",") 
		local byby by(`byvar', compact noixla noiyla ///
		noixti noiyti legend(off) `byopts') 
	}

	`mesh' /// 
	scatter `V' `U' if `touse', yscale(off) xscale(off) ///
	`byby' plotregion(style(none)) `options' 
end 
