*! 1.1.0 NJC 7 Sept 2008
*! 1.0.0 NJC 23 March 2007
program logratioplot
	version 8
	syntax varlist(min=3 max=3) [if] [in] ///
	[, mesh MESH2(str asis) plot(str asis) addplot(str asis) * ] 

	marksample touse
	qui count if `touse'
	if r(N) == 0 error 2000 

	if `"`mesh'`mesh2'"' != "" { 
		foreach t in 118 127 136 145 154 163 172 181  ///
        	             217 226 235 244 253 262 271      ///
			     316 325 334 343 352 361          ///
			     415 424 433 442 451              ///
			     514 523 532 541                  ///
			     613 622 631                      ///
			     712 721                          ///
			     811 {                           
	
			forval i = 1/3 { 
				local c`i' = substr("`t'",`i',1) 
			}

			local v = ln(`c1' / `c3')
			local u = ln(`c2' / `c3') 

			local call `" `call' `v' `u' (0) "`t'" "' 
		} 
		local call scatteri `call', ms(i) mlabcolor(gs10) `mesh2' 
	} 

	tempvar V U 
	tokenize "`varlist'" 
	args X Y Z 

	quietly { 
		gen `V' = ln(`X' / `Z') if `touse' 
		count if missing(`V') & `touse' 
		if r(N) { 
			if r(N) > 1 local s "s" 
			di as err "`r(N)' missing`s' in ln(`X'/`Z')"
		} 

		gen `U' = ln(`Y' / `Z') if `touse' 
		count if missing(`U') & `touse' 
		if r(N) { 
			if r(N) > 1 local s "s" 
			di as err "`r(N)' missing`s' in ln(`Y'/`Z')"
		} 
	} 
	
	twoway `call' || scatter `V' `U' if `touse',            ///
	legend(off)                                             ///
	yti("ln(`X' / `Z')") xti("ln(`Y' / `Z')")               /// 
	`options' ||                                            ///
	`plot'    ||                                            ///
	`addplot' 
end 
